#ifndef __BOX_H__
#define __BOX_H__

// box.h -- handles box-specific devices

#include <stdlib.h>
#include "btkcam.h"

#include "cam.h"
#include "ca.h"

#ifdef WIN32
#include "win32.h"
#else
#endif

#define BOX_COUNT 3

struct box_devices
{
	char ca_device_path[32];
	char demux_device_path[32];
	char cam_socket_path[32];
};

class box
{
	private:
	box(void);
	~box(void);
	static struct box_devices devices[BOX_COUNT];
	static int ca_device_fd[8];

	public:
	static unsigned int type;
	
	static char *get_ca_device_path( void );
	static char *get_demux_device_path( void );
	static char *get_cam_socket_path( void );
	
	static void close_ca_devices( void );
	static int get_ca_device(int device_index, service* handler);
	static int get_demux_device(int device_index, service* handler);
	static int set_ca_pid(int device_index, ca_pid_t* service_pid, service* handler);
	
	static int start_filter(int demux_descriptor, unsigned short pid, unsigned char table, unsigned char mask, unsigned int timeout, service* handler);
	static void stop_filter(int demux_descriptor, service* handler );
	static void write_control_words(service* handler);
	
	static void on_screen_message( char *message );
};

#endif
